Index: trunk/NEMOGCM/NEMO/LIM_SRC_2/limdmp_2.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_2/limdmp_2.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_2/limdmp_2.F90	(revision 2528)
@@ -2,169 +2,170 @@
    !!======================================================================
    !!                       ***  MODULE limdmp_2   ***
-   !!  Ice model : restoring Ice thickness and Fraction leads
+   !!  LIM-2 ice model : restoring Ice thickness and Fraction leads
    !!======================================================================
-   !! History :   2.0  !  04-04 (S. Theetten) Original code
+   !! History :   2.0  !  2004-04 (S. Theetten) Original code
+   !!             3.3  !  2010-06 (J.-M. Molines) use of fldread
    !!----------------------------------------------------------------------
-#if defined key_lim2   &&   defined key_tradmp
+#if defined key_lim2
    !!----------------------------------------------------------------------
-   !!   'key_lim2'  AND                               LIM 2.0 sea-ice model
-   !!   'key_tradmp'                                                Damping
-   !!----------------------------------------------------------------------
+   !!   'key_lim2'                                    LIM 2.0 sea-ice model
    !!----------------------------------------------------------------------
    !!   lim_dmp_2      : ice model damping
    !!----------------------------------------------------------------------
    USE in_out_manager  ! I/O manager
-   USE phycst          ! physical constants
-   USE ice_2
-   USE tradmp
-   USE dom_oce
-   USE oce
-   USE iom
+   USE ice_2           ! ice variables 
+   USE sbc_oce, ONLY : nn_fsbc ! for fldread
+   USE dom_oce         ! for mi0; mi1 etc ...
+   USE fldread         ! read input fields
    
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   lim_dmp_2     ! called by ice_step_2
+   PUBLIC   lim_dmp_2     ! called by sbc_ice_lim2
+
+   REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::   resto_ice   ! restoring coeff. on ICE   [s-1]
+
+   INTEGER, PARAMETER :: jp_hicif = 1 , jp_frld = 2
+   TYPE(FLD), ALLOCATABLE, DIMENSION(:) :: sf_icedmp    ! structure of ice damping input
    
-   INTEGER                        ::   nice1, nice2,  &  ! first and second record used
-      &                                inumice_dmp       ! logical unit for ice variables (damping)
-   REAL(wp), DIMENSION(jpi,jpj)   ::   hicif_dta  ,   &  ! ice thickness at a given time
-      &                                frld_dta          ! fraction lead at a given time
-   REAL(wp), DIMENSION(jpi,jpj,2) ::   hicif_data ,   &  ! ice thickness data at two consecutive times
-      &                                frld_data         ! fraction lead data at two consecutive times
-
    !! * Substitution
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   LIM 2.0 , UCL-LOCEAN-IPSL  (2006)
+   !! NEMO/LIM 3.3 , UCL-NEMO-consortium (2010) 
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-
 CONTAINS
 
-   SUBROUTINE lim_dmp_2(kt)
+   SUBROUTINE lim_dmp_2( kt )
       !!-------------------------------------------------------------------
-      !!                   ***  ROUTINE lim_dmp_2 ***
+      !!                   ***  ROUTINE lim_dmp_2  ***
       !!
-      !! ** purpose : ice model damping : restoring ice thickness and 
-      !!              fraction leads
+      !! ** purpose : ice model damping : restoring ice thickness and fraction leads
       !!
-      !! ** method  : the key_tradmp must be used to compute resto(:,:) coef.
+      !! ** method  : the key_tradmp must be used to compute resto(:,:,1) coef.
       !!---------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt     ! ocean time-step
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step
       !
-      INTEGER             ::   ji, jj         ! dummy loop indices
+      INTEGER  ::   ji, jj         ! dummy loop indices
+      REAL(wp) ::   zfrld, zhice   ! local scalars
       !!---------------------------------------------------------------------
       !
-      CALL dta_lim_2( kt )
-
-      DO jj = 2, jpjm1
-         DO ji = fs_2, fs_jpim1   ! vector opt.
-            hicif(ji,jj) = hicif(ji,jj) - rdt_ice * resto(ji,jj,1) * ( hicif(ji,jj) - hicif_dta(ji,jj) )
-            frld(ji,jj)  = frld (ji,jj) - rdt_ice * resto(ji,jj,1) * ( frld(ji,jj)  - frld_dta (ji,jj) )  
-         END DO
-      END DO
+      IF (kt == nit000)  THEN 
+         IF(lwp) WRITE(numout,*)
+         IF(lwp) WRITE(numout,*) 'lim_dmp_2 : Ice thickness and ice concentration restoring'
+         IF(lwp) WRITE(numout,*) '~~~~~~~~~~'
+         !
+         ! ice_resto_init create resto_ice (in 1/s) for restoring ice parameters near open boundaries.
+         ! Double check this routine to verify if it corresponds to your config
+         CALL lim_dmp_init
+      ENDIF
+      !
+      IF( ln_limdmp ) THEN   ! ice restoring in this case
+         !
+         CALL fld_read( kt, nn_fsbc, sf_icedmp )
+         !
+!CDIR COLLAPSE
+         hicif(:,:) = MAX( 0._wp,                     &        ! h >= 0         avoid spurious out of physical range
+            &         hicif(:,:) - rdt_ice * resto_ice(:,:,1) * ( hicif(:,:) - sf_icedmp(jp_hicif)%fnow(:,:,1) )  ) 
+!CDIR COLLAPSE
+         hicif(:,:) = MAX( 0._wp, MIN( 1._wp,         &        ! 0<= frld<=1    values which blow the run up
+            &         frld (:,:) - rdt_ice * resto_ice(:,:,1) * ( frld (:,:) - sf_icedmp(jp_frld )%fnow(:,:,1) )  )  )
+         !
+      ENDIF
       !
    END SUBROUTINE lim_dmp_2
 
 
-   SUBROUTINE dta_lim_2( kt ) 
+   SUBROUTINE lim_dmp_init
       !!----------------------------------------------------------------------
-      !!                   ***  ROUTINE dta_lim_2  ***
+      !!                   ***  ROUTINE lim_dmp_init  ***
       !!
-      !! ** Purpose :   Reads monthly ice thickness and fraction lead  data
+      !! ** Purpose :   Initialization for the ice thickness and concentration 
+      !!                restoring
+      !!              restoring will be used. It is used to mimic ice open
+      !!              boundaries.
       !!
-      !! ** Method  :   Read on unit numicedt the interpolated ice variable
-      !!      onto the model grid.
-      !!      Data begin at january.
-      !!      The value is centered at the middle of month.
-      !!      In the opa model, kt=1 agree with january 1.
-      !!      At each time step, a linear interpolation is applied between
-      !!      two monthly values.
+      !! ** Method  :  ?????
       !!      
-      !! ** Action  :   define hicif_dta and frld_dta arrays at time-step kt
+      !! ** Action  :   define resto_ice(:,:,1)
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(in) ::   kt     ! ocean time-step
+      INTEGER  :: ji, jj, jk       ! dummy loop indices
+      INTEGER  :: irelax, ierror   ! error flag for allocation
       !
-      INTEGER  ::   imois, iman, i15          ! temporary integers
-      REAL(wp) ::   zxy
+      REAL(wp) :: zdmpmax, zdmpmin, zfactor, zreltim ! temporary scalar
+      !
+      CHARACTER(len=100)           ::   cn_dir       ! Root directory for location of ssr files
+      TYPE(FLD_N), DIMENSION (2)   ::   sl_icedmp    ! informations about the icedmp  field to be read
+      TYPE(FLD_N)                  ::   sn_hicif     ! 
+      TYPE(FLD_N)                  ::   sn_frld      ! 
+      NAMELIST/namice_dmp/ cn_dir, ln_limdmp, sn_hicif, sn_frld
       !!----------------------------------------------------------------------
+      !
+      ! 1)  initialize fld read structure for input data 
+      !     --------------------------------------------
+      ln_limdmp = .false.                 !* set file information (default values)
+      cn_dir    = './'
+      ! (NB: frequency positive => hours, negative => months)
+      !                !    file     ! frequency ! variable ! time intep !  clim   ! 'yearly' or ! weights  ! rotation !
+      !                !    name     !  (hours)  !  name    !   (T/F)    !  (T/F)  !  'monthly'  ! filename ! pairs    !
+      sn_hicif = FLD_N( 'ice_damping ', -1       , 'hicif'  ,  .true.    , .true.  ,  'yearly'   ,  ''      ,  ''      )
+      sn_frld  = FLD_N( 'ice_damping ', -1       , 'frld'   ,  .true.    , .true.  ,  'yearly'   ,  ''      ,  ''      )
 
-      ! 0. Initialization
-      ! -----------------
-      iman  = INT( raamo )
-!!! better but change the results     i15 = INT( 2*FLOAT( nday ) / ( FLOAT( nobis(nmonth) ) + 0.5 ) )
-      i15   = nday / 16
-      imois = nmonth + i15 - 1
-      IF( imois == 0 ) imois = iman
-      
-      ! 1. First call kt=nit000: Initialization and Open
-      ! -----------------------
-      IF( kt == nit000 ) THEN
-         nice1 = 0
-         IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'dtalim : Ice thickness and lead fraction  monthly fields'
-         IF(lwp) WRITE(numout,*) '~~~~~~'
-         IF(lwp) WRITE(numout,*) '             NetCDF FORMAT'
-         IF(lwp) WRITE(numout,*)
-         ! open file
-         CALL iom_open( 'ice_damping_ATL4.nc', inumice_dmp )
+      REWIND( numnam_ice )                !* read in namelist_ice namicedmp
+      READ  ( numnam_ice, namice_dmp )
+      !
+      IF ( lwp ) THEN                     !* control print
+         WRITE (numout,*)'     lim_dmp_init : lim_dmp initialization ' 
+         WRITE (numout,*)'       Namelist namicedmp read '
+         WRITE (numout,*)'         Ice restoring (T) or not (F) ln_limdmp =', ln_limdmp 
+         WRITE (numout,*)
+         WRITE (numout,*)'     CAUTION : here hard coded ice restoring along northern and southern boundaries'
+         WRITE (numout,*)'               adapt the lim_dmp_init routine to your needs'
       ENDIF
 
+      ! 2)  initialise resto_ice    ==>  config dependant !
+      !     --------------------         ++++++++++++++++
+      !
+      IF( ln_limdmp ) THEN                !* ice restoring is used, follow initialization
+         ! 
+         sl_icedmp ( jp_hicif ) = sn_hicif
+         sl_icedmp ( jp_frld  ) = sn_frld
+         ALLOCATE ( sf_icedmp (2) , resto_ice(jpi,jpj,1), STAT=ierror )
+         IF( ierror > 0 ) THEN
+            CALL ctl_stop( 'lim_dmp_init: unable to allocate sf_icedmp structure or resto_ice array' )   ;   RETURN
+         ENDIF
+         ALLOCATE( sf_icedmp(jp_hicif)%fnow(jpi,jpj,1) , sf_icedmp(jp_hicif)%fdta(jpi,jpj,1,2) )
+         ALLOCATE( sf_icedmp(jp_frld )%fnow(jpi,jpj,1) , sf_icedmp(jp_frld )%fdta(jpi,jpj,1,2) )
+         !                         ! fill sf_icedmp with sn_icedmp and control print
+         CALL fld_fill( sf_icedmp, sl_icedmp, cn_dir, 'lim_dmp_init', 'Ice  restoring input data', 'namicedmp' )
+      
+         resto_ice(:,:,:) = 0._wp
+         !      Re-calculate the North and South boundary restoring term
+         !      because those boundaries may change with the prescribed zoom area.
+         !
+         irelax  = 16                     ! width of buffer zone with respect to close boundary
+         zdmpmax = 10._wp                 ! max restoring time scale  (days) (low restoring)
+         zdmpmin = rdt_ice / 86400._wp    ! min restoring time scale  (days) (high restoring)
+         !                                ! days / grid-point
+         zfactor = ( zdmpmax - zdmpmin ) / REAL( irelax, wp )
 
-      ! 2. Read monthly file
-      ! --------------------
-      IF( ( kt == nit000 ) .OR. imois /= nice1 ) THEN
-         !
-         ! Calendar computation
-         nice1 = imois        ! first file record used 
-         nice2 = nice1 + 1    ! last  file record used
-         nice1 = MOD( nice1, iman )
-         nice2 = MOD( nice2, iman )
-         IF( nice1 == 0 )   nice1 = iman
-         IF( nice2 == 0 )   nice2 = iman
-         IF(lwp) WRITE(numout,*) 'first record file used nice1 ', nice1
-         IF(lwp) WRITE(numout,*) 'last  record file used nice2 ', nice2
-         
-         ! Read monthly ice thickness Levitus 
-         CALL iom_get( inumice_dmp, jpdom_data, 'iicethic', hicif_data(:,:,1), nice1 ) 
-         CALL iom_get( inumice_dmp, jpdom_data, 'iicethic', hicif_data(:,:,2), nice2 ) 
-         
-         ! Read monthly ice thickness Levitus 
-         CALL iom_get( inumice_dmp, jpdom_data, 'ileadfra', frld_data(:,:,1), nice1 ) 
-         CALL iom_get( inumice_dmp, jpdom_data, 'ileadfra', frld_data(:,:,2), nice2 ) 
-         
-         ! The fraction lead read in the file is in fact the 
-         ! ice concentration which is 1 - the fraction lead
-         frld_data = 1 - frld_data          
-         
-         IF(lwp) THEN
-            WRITE(numout,*)
-            WRITE(numout,*) ' Ice thickness month ', nice1,' and ', nice2
-            WRITE(numout,*)
-            WRITE(numout,*) ' Ice thickness month = ', nice1
-            CALL prihre( hicif_data(1,1,1), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
-            WRITE(numout,*)
-            WRITE(numout,*) ' Fraction lead months ', nice1,' and ', nice2
-            WRITE(numout,*)
-            WRITE(numout,*) ' Fraction lead month = ', nice1
-            CALL prihre( frld_data(1,1,1), jpi, jpj, 1, jpi, 20, 1, jpj, 20, 1., numout )
-         ENDIF
+         !    South boundary restoring term
+         ! REM: if there is no ice in the model and in the data, 
+         !      no restoring even with non zero resto_ice
+         DO jj = mj0(jpjzoom - 1 + 1), mj1(jpjzoom -1 + irelax)
+            zreltim = zdmpmin + zfactor * ( mjg(jj) - jpjzoom + 1 )
+            resto_ice(:,jj,:) = 1._wp / ( zreltim * 86400._wp )
+         END DO
 
-         CALL FLUSH(numout)
-
+         ! North boundary restoring term
+         DO jj =  mj0(jpjzoom -1 + jpjglo - irelax), mj1(jpjzoom - 1 + jpjglo)
+            zreltim = zdmpmin + zfactor * (jpjglo - ( mjg(jj) - jpjzoom + 1 ))
+            resto_ice(:,jj,:) = 1.e0 / ( zreltim * 86400 )
+         END DO
       ENDIF
-        
-      ! 3. At every time step compute ice thickness and fraction lead data
-      ! ------------------------------------------------------------------
-      zxy = FLOAT( nday + 15 - 30 * i15 ) / 30.
-      hicif_dta(:,:) = (1.-zxy) * hicif_data(:,:,1) + zxy * hicif_data(:,:,2)
-      frld_dta (:,:) = (1.-zxy) * frld_data (:,:,1) + zxy * frld_data (:,:,2)
-
-      IF( kt == nitend )   CALL iom_close( inumice_dmp )
       !
-   END SUBROUTINE dta_lim_2
-
+   END SUBROUTINE lim_dmp_init
+   
 #else
    !!----------------------------------------------------------------------
Index: trunk/NEMOGCM/NEMO/LIM_SRC_2/limdyn_2.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_2/limdyn_2.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_2/limdyn_2.F90	(revision 2528)
@@ -4,8 +4,9 @@
    !!   Sea-Ice dynamics :  
    !!======================================================================
-   !! History :   1.0  !  01-04  (LIM)  Original code
-   !!             2.0  !  02-08  (C. Ethe, G. Madec)  F90, mpp
-   !!             2.0  !  03-08  (C. Ethe) add lim_dyn_init
-   !!             2.0  !  06-07  (G. Madec)  Surface module
+   !! History :  1.0  ! 2001-04  (LIM)  Original code
+   !!            2.0  ! 2002-08  (C. Ethe, G. Madec)  F90, mpp
+   !!            2.0  ! 2003-08  (C. Ethe) add lim_dyn_init
+   !!            2.0  ! 2006-07  (G. Madec)  Surface module
+   !!            3.3  ! 2009-05 (G. Garric, C. Bricaud) addition of the lim2_evp case
    !!---------------------------------------------------------------------
 #if defined key_lim2
@@ -16,32 +17,30 @@
    !!    lim_dyn_init_2 : initialization and namelist read
    !!----------------------------------------------------------------------
-   USE dom_oce        ! ocean space and time domain
-   USE sbc_oce        !
-   USE phycst         !
-   USE ice_2          !
-   USE dom_ice_2      !
-   USE limistate_2    !
-   USE limrhg_2       ! ice rheology
-
-   USE lbclnk         !
-   USE lib_mpp        !
-   USE in_out_manager ! I/O manager
-   USE prtctl         ! Print control
+   USE dom_oce          ! ocean space and time domain
+   USE sbc_oce          ! ocean surface boundary condition
+   USE phycst           ! physical constant
+   USE ice_2            ! LIM-2: ice variables
+   USE sbc_ice          ! Surface boundary condition: sea-ice fields
+   USE dom_ice_2        ! LIM-2: ice domain
+   USE limistate_2      ! LIM-2: initial state
+   USE limrhg_2         ! LIM-2: VP  ice rheology
+   USE limrhg           ! LIM  : EVP ice rheology
+   USE lbclnk           ! lateral boundary condition - MPP link
+   USE lib_mpp          ! MPP library
+   USE in_out_manager   ! I/O manager
+   USE prtctl           ! Print control
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   lim_dyn_2 ! routine called by sbc_ice_lim
-
-   !! * Module variables
-   REAL(wp)  ::  rone    = 1.e0   ! constant value
-
+   PUBLIC   lim_dyn_2   ! routine called by sbc_ice_lim
+
+   !! * Substitutions
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2006) 
+   !! NEMO/LIM2 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -83,9 +82,11 @@
          ! ---------------------------------------------------
          
-         IF( lk_mpp .OR. nbit_cmp == 1 ) THEN                    ! mpp: compute over the whole domain
+         IF( lk_mpp .OR. lk_mpp_rep ) THEN                    ! mpp: compute over the whole domain
             i_j1 = 1   
             i_jpj = jpj
             IF(ln_ctl)   CALL prt_ctl_info( 'lim_dyn  :    i_j1 = ', ivar1=i_j1, clinfo2=' ij_jpj = ', ivar2=i_jpj )
-            CALL lim_rhg_2( i_j1, i_jpj )
+            IF( lk_lim2_vp )   THEN   ;   CALL lim_rhg_2( i_j1, i_jpj )             !  VP rheology
+            ELSE                      ;   CALL lim_rhg  ( i_j1, i_jpj )             ! EVP rheology
+            ENDIF
             !
          ELSE                                 ! optimization of the computational area
@@ -105,9 +106,13 @@
                   i_j1 = i_j1 + 1
                END DO
-               i_j1 = MAX( 1, i_j1-1 )
-               IF(ln_ctl)   WRITE(numout,*) 'lim_dyn : NH i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
-               ! 
-               CALL lim_rhg_2( i_j1, i_jpj )
-               ! 
+               IF( lk_lim2_vp )   THEN             ! VP  rheology
+                  i_j1 = MAX( 1, i_j1-1 )
+                  CALL lim_rhg_2( i_j1, i_jpj )
+               ELSE                                ! EVP rheology
+                  i_j1 = MAX( 1, i_j1-2 )
+                  CALL lim_rhg( i_j1, i_jpj )
+               ENDIF
+               IF(ln_ctl)   WRITE(numout,*) 'lim_dyn : NH i_j1 = ', i_j1, 'ij_jpj = ', i_jpj
+               !
                ! Southern hemisphere
                i_j1  =  1 
@@ -116,9 +121,13 @@
                   i_jpj = i_jpj - 1
                END DO
-               i_jpj = MIN( jpj, i_jpj+2 )
-               IF(ln_ctl)   WRITE(numout,*) 'lim_dyn : SH i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
-               ! 
-               CALL lim_rhg_2( i_j1, i_jpj )
-               ! 
+               IF( lk_lim2_vp )   THEN             ! VP  rheology
+                  i_jpj = MIN( jpj, i_jpj+2 )
+                  CALL lim_rhg_2( i_j1, i_jpj )
+               ELSE                                ! EVP rheology
+                  i_jpj = MIN( jpj, i_jpj+1 )
+                  CALL lim_rhg( i_j1, i_jpj )
+               ENDIF
+               IF(ln_ctl)   WRITE(numout,*) 'lim_dyn : SH i_j1 = ', i_j1, 'ij_jpj = ', i_jpj
+               !
             ELSE                                 ! local domain extends over one hemisphere only
                !                                 ! Rheology is computed only over the ice cover
@@ -134,9 +143,15 @@
                   i_jpj = i_jpj - 1
                END DO
-               i_jpj = MIN( jpj, i_jpj+2)
-    
+               i_jpj = MIN( jpj, i_jpj+2 )
+               ! 
+               IF( lk_lim2_vp )   THEN             ! VP  rheology
+                  i_jpj = MIN( jpj, i_jpj+2 )
+                  CALL lim_rhg_2( i_j1, i_jpj )                !  VP rheology
+               ELSE                                ! EVP rheology
+                  i_j1  = MAX( 1  , i_j1-2  )
+                  i_jpj = MIN( jpj, i_jpj+1 )
+                  CALL lim_rhg  ( i_j1, i_jpj )                ! EVP rheology
+               ENDIF
                IF(ln_ctl)   WRITE(numout,*) 'lim_dyn : one hemisphere: i_j1 = ', i_j1, ' ij_jpj = ', i_jpj
-               ! 
-               CALL lim_rhg_2( i_j1, i_jpj )
                !
             ENDIF
@@ -148,18 +163,23 @@
          ! computation of friction velocity
          ! --------------------------------
-         ! ice-ocean velocity at U & V-points (u_ice v_ice at I-point ; ssu_m, ssv_m at U- & V-points)
-         
-         DO jj = 1, jpjm1
-            DO ji = 1, jpim1   ! NO vector opt.
-               zu_io(ji,jj) = 0.5 * ( u_ice(ji+1,jj+1) + u_ice(ji+1,jj  ) ) - ssu_m(ji,jj)
-               zv_io(ji,jj) = 0.5 * ( v_ice(ji+1,jj+1) + v_ice(ji  ,jj+1) ) - ssv_m(ji,jj)
-            END DO
-         END DO
+         SELECT CASE( cp_ice_msh )           ! ice-ocean relative velocity at u- & v-pts
+         CASE( 'C' )                               ! EVP : C-grid ice dynamics
+            zu_io(:,:) = u_ice(:,:) - ssu_m(:,:)           ! ice-ocean & ice velocity at ocean velocity points
+            zv_io(:,:) = v_ice(:,:) - ssv_m(:,:)
+         CASE( 'I' )                               ! VP  : B-grid ice dynamics (I-point) 
+            DO jj = 1, jpjm1                               ! u_ice v_ice at I-point ; ssu_m, ssv_m at U- & V-points
+               DO ji = 1, jpim1   ! NO vector opt.         !
+                  zu_io(ji,jj) = 0.5_wp * ( u_ice(ji+1,jj+1) + u_ice(ji+1,jj  ) ) - ssu_m(ji,jj)
+                  zv_io(ji,jj) = 0.5_wp * ( v_ice(ji+1,jj+1) + v_ice(ji  ,jj+1) ) - ssv_m(ji,jj)
+               END DO
+            END DO
+         END SELECT
+
          ! frictional velocity at T-point
+         zcoef = 0.5_wp * cw
          DO jj = 2, jpjm1
             DO ji = 2, jpim1   ! NO vector opt. because of zu_io
-               ust2s(ji,jj) = 0.5 * cw                                                          &
-                  &         * (  zu_io(ji,jj) * zu_io(ji,jj) + zu_io(ji-1,jj) * zu_io(ji-1,jj)   &
-                  &            + zv_io(ji,jj) * zv_io(ji,jj) + zv_io(ji,jj-1) * zv_io(ji,jj-1)   ) * tms(ji,jj)
+               ust2s(ji,jj) = zcoef * (  zu_io(ji,jj) * zu_io(ji,jj) + zu_io(ji-1,jj) * zu_io(ji-1,jj)   &
+                  &                    + zv_io(ji,jj) * zv_io(ji,jj) + zv_io(ji,jj-1) * zv_io(ji,jj-1)   ) * tms(ji,jj)
             END DO
          END DO
@@ -170,6 +190,6 @@
          DO jj = 2, jpjm1
             DO ji = fs_2, fs_jpim1   ! vector opt.
-               ust2s(ji,jj) = zcoef * tms(ji,jj) * SQRT(  utau(ji,jj) * utau(ji,jj) + utau(ji-1,jj) * utau(ji-1,jj)   &
-                  &                                     + vtau(ji,jj) * vtau(ji,jj) + vtau(ji,jj-1) * vtau(ji,jj-1) )
+               ust2s(ji,jj) = zcoef * SQRT(  utau(ji,jj) * utau(ji,jj) + utau(ji-1,jj) * utau(ji-1,jj)   &
+                  &                        + vtau(ji,jj) * vtau(ji,jj) + vtau(ji,jj-1) * vtau(ji,jj-1)   ) * tms(ji,jj)
             END DO
          END DO
@@ -180,5 +200,5 @@
       !
       IF(ln_ctl)   CALL prt_ctl(tab2d_1=ust2s , clinfo1=' lim_dyn  : ust2s :')
-
+      !
    END SUBROUTINE lim_dyn_2
 
@@ -198,5 +218,6 @@
       NAMELIST/namicedyn/ epsd, alpha,     &
          &                dm, nbiter, nbitdr, om, resl, cw, angvg, pstar,   &
-         &                c_rhg, etamn, creepl, ecc, ahi0
+         &                c_rhg, etamn, creepl, ecc, ahi0,                  &
+         &                nevp, telast,alphaevp
       !!-------------------------------------------------------------------
 
@@ -223,4 +244,13 @@
          WRITE(numout,*) '       eccentricity of the elliptical yield curve       ecc    = ', ecc
          WRITE(numout,*) '       horizontal diffusivity coeff. for sea-ice        ahi0   = ', ahi0
+         WRITE(numout,*) '       number of iterations for subcycling nevp   = ', nevp
+         WRITE(numout,*) '       timescale for elastic waves telast = ', telast
+         WRITE(numout,*) '       coefficient for the solution of int. stresses alphaevp = ', alphaevp
+      ENDIF
+      !
+      IF( angvg /= 0._wp .AND. .NOT.lk_lim2_vp ) THEN
+         CALL ctl_warn( 'lim_dyn_init_2: turning angle for oceanic stress not properly coded for EVP ',   &
+            &           '(see limsbc_2 module). We force  angvg = 0._wp'  )
+         angvg = 0._wp
       ENDIF
 
Index: trunk/NEMOGCM/NEMO/LIM_SRC_2/limhdf_2.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_2/limhdf_2.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_2/limhdf_2.F90	(revision 2528)
@@ -32,7 +32,7 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2005) 
+   !! NEMO/LIM2 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
Index: trunk/NEMOGCM/NEMO/LIM_SRC_2/limistate_2.F90
===================================================================
--- trunk/NEMOGCM/NEMO/LIM_SRC_2/limistate_2.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/LIM_SRC_2/limistate_2.F90	(revision 2528)
@@ -46,7 +46,7 @@
    REAL(wp) ::   zone      = 1.e0     ! constant value = 1
    !!----------------------------------------------------------------------
-   !!   LIM 2.0,  UCL-LOCEAN-IPSL (2006) 
+   !! NEMO/LIM2 3.3 , UCL - NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
